/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
#ifndef _AFFIX_HXX_
#define _AFFIX_HXX_

#include "license.readme"
#include "myspAffixmgr.h"

/* Modifications for mozilla Copyright 2001 David Einstein Deinst@world.std.com  */

#define SETSIZE         256
#define XPRODUCT        1


struct affentry
{
  nsSharableCString strip;
  nsSharableCString appnd;
  PRUint16  numconds;
  PRInt16  cpflag;
  char   conds[SETSIZE];
};



class myspAffix
{
public:
  myspAffix(myspAffixMgr* pmgr, unsigned char a, int num, PRInt16 ff );
  virtual ~myspAffix();
  unsigned char GetFlag() {return flag;}
  nsresult SetAffentry(int num,const nsAFlatCString &line);
protected:
  void encodeit(struct affentry * ptr,const nsACString &code);
  unsigned char       flag;
  myspAffixMgr*       pmyMgr;
  PRInt32             numents;
  struct affentry *   first;
};


class myspPrefix : public myspAffix
{
public:
  myspPrefix(myspAffixMgr* pmgr, unsigned char a, PRInt32 num, PRInt16 ff );
  const char * check(const nsAFlatCString &word);
};



class myspSuffix : public myspAffix
{
public:
  myspSuffix(myspAffixMgr* pmgr, unsigned char a, PRInt32 num, PRInt16 ff );
  const char * check(const nsAFlatCString &word, PRInt32 optflags, myspPrefix* ppfx);
};

#endif

