/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
#ifndef _AFFIXMGR_HXX_
#define _AFFIXMGR_HXX_
#include "license.readme"
#include "nsString.h"
#include "mozIPersonalDictionary.h"
#include "mozCStr2CStrHashtable.h"
#include "nsIFileStreams.h"

/* Modifications for mozilla Copyright 2001 David Einstein Deinst@world.std.com  */



// shamelesly stolen from nsDirectoryService.cpp
// Probably should move to nsDirectoryService.h?
#if defined(XP_MAC)
#define COMPONENT_DIRECTORY "Components"
#else
#define COMPONENT_DIRECTORY "components" 
#endif 

#define MAXAFFIXES      256



class myspPrefix;
class myspSuffix;

class myspAffixMgr
{
public:
 
  myspAffixMgr();
  ~myspAffixMgr();
  nsresult GetPersonalDictionary(mozIPersonalDictionary * *aPersonalDictionary);
  nsresult SetPersonalDictionary(mozIPersonalDictionary * aPersonalDictionary);
  PRBool check(const nsAFlatCString &word);
  const char * affix_check(const nsAFlatCString &word);
  const char * lookup(const nsAFlatCString &word);
  const char * cross_check(const nsAFlatCString &word, int sfxopts, myspPrefix* ppfx);
  nsString get_encoding();
  nsCString get_try_string();
  nsresult Load(const nsString& aDictionary);

protected:
  nsresult LoadDictionary(nsIInputStream *strm);
  nsresult  parse_file(nsIInputStream *strm);

  PRUint32                 numpfx;
  PRUint32                 numsfx;
  myspPrefix            **pTable;
  PRUint32                cappfx;
  myspSuffix            **sTable;
  PRUint32                capsfx;
  nsCString               trystring;
  nsString                mEncoding;
  mozCStr2CStrHashtable mHashTable;
  nsCOMPtr<mozIPersonalDictionary> mPersonalDictionary;
};

#endif
